<?php

/**
* getLookupMainTableSettings - tests whether the lookup link exists between the tables
*
*  returns array with ProjectSettings class for main table if the link exists in project settings.
*  returns NULL otherwise
*/
function getLookupMainTableSettings($lookupTable, $mainTableShortName, $mainField, $desiredPage = "")
{
	global $lookupTableLinks;
	if(!isset($lookupTableLinks[$lookupTable]))
		return null;
	if(!isset($lookupTableLinks[$lookupTable][$mainTableShortName.".".$mainField]))
		return null;
	$arr = &$lookupTableLinks[$lookupTable][$mainTableShortName.".".$mainField];
	$effectivePage = $desiredPage;
	if(!isset($arr[$effectivePage]))
	{
		$effectivePage = PAGE_EDIT;
		if(!isset($arr[$effectivePage]))
		{
			if($desiredPage == "" && 0 < count($arr))
			{
				$effectivePage = $arr[0];
			}
			else
				return null;
		}
	}
	return new ProjectSettings($arr[$effectivePage]["table"], $effectivePage);
}

/** 
* $lookupTableLinks array stores all lookup links between tables in the project
*/
function InitLookupLinks()
{
	global $lookupTableLinks;

	$lookupTableLinks = array();

		if( !isset( $lookupTableLinks["imd_tipo_deporte"] ) ) {
			$lookupTableLinks["imd_tipo_deporte"] = array();
		}
		if( !isset( $lookupTableLinks["imd_tipo_deporte"]["imd_categoria_deporte.Codigo_Deporte"] )) {
			$lookupTableLinks["imd_tipo_deporte"]["imd_categoria_deporte.Codigo_Deporte"] = array();
		}
		$lookupTableLinks["imd_tipo_deporte"]["imd_categoria_deporte.Codigo_Deporte"]["edit"] = array("table" => "imd_categoria_deporte", "field" => "Codigo_Deporte", "page" => "edit");
		if( !isset( $lookupTableLinks["imd_alumnos_imdepor"] ) ) {
			$lookupTableLinks["imd_alumnos_imdepor"] = array();
		}
		if( !isset( $lookupTableLinks["imd_alumnos_imdepor"]["imd_matricula_alumno.Codigo_Alumno"] )) {
			$lookupTableLinks["imd_alumnos_imdepor"]["imd_matricula_alumno.Codigo_Alumno"] = array();
		}
		$lookupTableLinks["imd_alumnos_imdepor"]["imd_matricula_alumno.Codigo_Alumno"]["edit"] = array("table" => "imd_matricula_alumno", "field" => "Codigo_Alumno", "page" => "edit");
		if( !isset( $lookupTableLinks["imd_tipo_deporte"] ) ) {
			$lookupTableLinks["imd_tipo_deporte"] = array();
		}
		if( !isset( $lookupTableLinks["imd_tipo_deporte"]["imd_matricula_alumno.Codigo_Deporte"] )) {
			$lookupTableLinks["imd_tipo_deporte"]["imd_matricula_alumno.Codigo_Deporte"] = array();
		}
		$lookupTableLinks["imd_tipo_deporte"]["imd_matricula_alumno.Codigo_Deporte"]["edit"] = array("table" => "imd_matricula_alumno", "field" => "Codigo_Deporte", "page" => "edit");
		if( !isset( $lookupTableLinks["imd_categoria_deporte"] ) ) {
			$lookupTableLinks["imd_categoria_deporte"] = array();
		}
		if( !isset( $lookupTableLinks["imd_categoria_deporte"]["imd_matricula_alumno.Codigo_CatDep"] )) {
			$lookupTableLinks["imd_categoria_deporte"]["imd_matricula_alumno.Codigo_CatDep"] = array();
		}
		$lookupTableLinks["imd_categoria_deporte"]["imd_matricula_alumno.Codigo_CatDep"]["edit"] = array("table" => "imd_matricula_alumno", "field" => "Codigo_CatDep", "page" => "edit");
		if( !isset( $lookupTableLinks["zdepartamentos"] ) ) {
			$lookupTableLinks["zdepartamentos"] = array();
		}
		if( !isset( $lookupTableLinks["zdepartamentos"]["zusuarios.CodigoDepto"] )) {
			$lookupTableLinks["zdepartamentos"]["zusuarios.CodigoDepto"] = array();
		}
		$lookupTableLinks["zdepartamentos"]["zusuarios.CodigoDepto"]["edit"] = array("table" => "zusuarios", "field" => "CodigoDepto", "page" => "edit");
		if( !isset( $lookupTableLinks["zpuestos"] ) ) {
			$lookupTableLinks["zpuestos"] = array();
		}
		if( !isset( $lookupTableLinks["zpuestos"]["zusuarios.Id_Puesto"] )) {
			$lookupTableLinks["zpuestos"]["zusuarios.Id_Puesto"] = array();
		}
		$lookupTableLinks["zpuestos"]["zusuarios.Id_Puesto"]["edit"] = array("table" => "zusuarios", "field" => "Id_Puesto", "page" => "edit");
		if( !isset( $lookupTableLinks["zdepartamentos"] ) ) {
			$lookupTableLinks["zdepartamentos"] = array();
		}
		if( !isset( $lookupTableLinks["zdepartamentos"]["admin_members.CodigoDepto"] )) {
			$lookupTableLinks["zdepartamentos"]["admin_members.CodigoDepto"] = array();
		}
		$lookupTableLinks["zdepartamentos"]["admin_members.CodigoDepto"]["edit"] = array("table" => "admin_members", "field" => "CodigoDepto", "page" => "edit");
		if( !isset( $lookupTableLinks["zpuestos"] ) ) {
			$lookupTableLinks["zpuestos"] = array();
		}
		if( !isset( $lookupTableLinks["zpuestos"]["admin_members.Id_Puesto"] )) {
			$lookupTableLinks["zpuestos"]["admin_members.Id_Puesto"] = array();
		}
		$lookupTableLinks["zpuestos"]["admin_members.Id_Puesto"]["edit"] = array("table" => "admin_members", "field" => "Id_Puesto", "page" => "edit");
		if( !isset( $lookupTableLinks["zdepartamentos"] ) ) {
			$lookupTableLinks["zdepartamentos"] = array();
		}
		if( !isset( $lookupTableLinks["zdepartamentos"]["admin_users.CodigoDepto"] )) {
			$lookupTableLinks["zdepartamentos"]["admin_users.CodigoDepto"] = array();
		}
		$lookupTableLinks["zdepartamentos"]["admin_users.CodigoDepto"]["edit"] = array("table" => "admin_users", "field" => "CodigoDepto", "page" => "edit");
		if( !isset( $lookupTableLinks["zpuestos"] ) ) {
			$lookupTableLinks["zpuestos"] = array();
		}
		if( !isset( $lookupTableLinks["zpuestos"]["admin_users.Id_Puesto"] )) {
			$lookupTableLinks["zpuestos"]["admin_users.Id_Puesto"] = array();
		}
		$lookupTableLinks["zpuestos"]["admin_users.Id_Puesto"]["edit"] = array("table" => "admin_users", "field" => "Id_Puesto", "page" => "edit");
		if( !isset( $lookupTableLinks["imd_tipo_deporte"] ) ) {
			$lookupTableLinks["imd_tipo_deporte"] = array();
		}
		if( !isset( $lookupTableLinks["imd_tipo_deporte"]["Registro_Alumnos_Online.Codigo_deporte"] )) {
			$lookupTableLinks["imd_tipo_deporte"]["Registro_Alumnos_Online.Codigo_deporte"] = array();
		}
		$lookupTableLinks["imd_tipo_deporte"]["Registro_Alumnos_Online.Codigo_deporte"]["edit"] = array("table" => "Registro Alumnos Online", "field" => "Codigo_deporte", "page" => "edit");
		if( !isset( $lookupTableLinks["imd_categoria_deporte"] ) ) {
			$lookupTableLinks["imd_categoria_deporte"] = array();
		}
		if( !isset( $lookupTableLinks["imd_categoria_deporte"]["Ficha_Futbol.Codigo_CatDep"] )) {
			$lookupTableLinks["imd_categoria_deporte"]["Ficha_Futbol.Codigo_CatDep"] = array();
		}
		$lookupTableLinks["imd_categoria_deporte"]["Ficha_Futbol.Codigo_CatDep"]["search"] = array("table" => "Ficha Futbol", "field" => "Codigo_CatDep", "page" => "search");
		if( !isset( $lookupTableLinks["imd_categoria_deporte"] ) ) {
			$lookupTableLinks["imd_categoria_deporte"] = array();
		}
		if( !isset( $lookupTableLinks["imd_categoria_deporte"]["Ficha_Baloncesto.Codigo_CatDep"] )) {
			$lookupTableLinks["imd_categoria_deporte"]["Ficha_Baloncesto.Codigo_CatDep"] = array();
		}
		$lookupTableLinks["imd_categoria_deporte"]["Ficha_Baloncesto.Codigo_CatDep"]["search"] = array("table" => "Ficha Baloncesto", "field" => "Codigo_CatDep", "page" => "search");
		if( !isset( $lookupTableLinks["imd_categoria_deporte"] ) ) {
			$lookupTableLinks["imd_categoria_deporte"] = array();
		}
		if( !isset( $lookupTableLinks["imd_categoria_deporte"]["Ficha_Volleyball.Codigo_CatDep"] )) {
			$lookupTableLinks["imd_categoria_deporte"]["Ficha_Volleyball.Codigo_CatDep"] = array();
		}
		$lookupTableLinks["imd_categoria_deporte"]["Ficha_Volleyball.Codigo_CatDep"]["search"] = array("table" => "Ficha Volleyball", "field" => "Codigo_CatDep", "page" => "search");
		if( !isset( $lookupTableLinks["imd_tipo_deporte"] ) ) {
			$lookupTableLinks["imd_tipo_deporte"] = array();
		}
		if( !isset( $lookupTableLinks["imd_tipo_deporte"]["Listado_Alumnos_de_Baloncesto.Codigo_Deporte"] )) {
			$lookupTableLinks["imd_tipo_deporte"]["Listado_Alumnos_de_Baloncesto.Codigo_Deporte"] = array();
		}
		$lookupTableLinks["imd_tipo_deporte"]["Listado_Alumnos_de_Baloncesto.Codigo_Deporte"]["search"] = array("table" => "Listado Alumnos de Baloncesto", "field" => "Codigo_Deporte", "page" => "search");
		if( !isset( $lookupTableLinks["imd_tipo_deporte"] ) ) {
			$lookupTableLinks["imd_tipo_deporte"] = array();
		}
		if( !isset( $lookupTableLinks["imd_tipo_deporte"]["Listado_de_Alumnos_Volleyball.Codigo_Deporte"] )) {
			$lookupTableLinks["imd_tipo_deporte"]["Listado_de_Alumnos_Volleyball.Codigo_Deporte"] = array();
		}
		$lookupTableLinks["imd_tipo_deporte"]["Listado_de_Alumnos_Volleyball.Codigo_Deporte"]["search"] = array("table" => "Listado de Alumnos Volleyball", "field" => "Codigo_Deporte", "page" => "search");
		if( !isset( $lookupTableLinks["imd_tipo_deporte"] ) ) {
			$lookupTableLinks["imd_tipo_deporte"] = array();
		}
		if( !isset( $lookupTableLinks["imd_tipo_deporte"]["Listado_de_Alumnos_Becados.Codigo_Deporte"] )) {
			$lookupTableLinks["imd_tipo_deporte"]["Listado_de_Alumnos_Becados.Codigo_Deporte"] = array();
		}
		$lookupTableLinks["imd_tipo_deporte"]["Listado_de_Alumnos_Becados.Codigo_Deporte"]["search"] = array("table" => "Listado de Alumnos Becados", "field" => "Codigo_Deporte", "page" => "search");
		if( !isset( $lookupTableLinks["imd_categoria_deporte"] ) ) {
			$lookupTableLinks["imd_categoria_deporte"] = array();
		}
		if( !isset( $lookupTableLinks["imd_categoria_deporte"]["Listado_de_Alumnos_de_Futbol_por_Categor_a.Codigo_CatDep"] )) {
			$lookupTableLinks["imd_categoria_deporte"]["Listado_de_Alumnos_de_Futbol_por_Categor_a.Codigo_CatDep"] = array();
		}
		$lookupTableLinks["imd_categoria_deporte"]["Listado_de_Alumnos_de_Futbol_por_Categor_a.Codigo_CatDep"]["search"] = array("table" => "Listado de Alumnos de Futbol por Categoría", "field" => "Codigo_CatDep", "page" => "search");
		if( !isset( $lookupTableLinks["imd_tipo_deporte"] ) ) {
			$lookupTableLinks["imd_tipo_deporte"] = array();
		}
		if( !isset( $lookupTableLinks["imd_tipo_deporte"]["imd_online_alumnos.Codigo_deporte"] )) {
			$lookupTableLinks["imd_tipo_deporte"]["imd_online_alumnos.Codigo_deporte"] = array();
		}
		$lookupTableLinks["imd_tipo_deporte"]["imd_online_alumnos.Codigo_deporte"]["edit"] = array("table" => "imd_online_alumnos", "field" => "Codigo_deporte", "page" => "edit");
		if( !isset( $lookupTableLinks["imd_tipo_deporte"] ) ) {
			$lookupTableLinks["imd_tipo_deporte"] = array();
		}
		if( !isset( $lookupTableLinks["imd_tipo_deporte"]["ficha_alumnos_online.Codigo_deporte"] )) {
			$lookupTableLinks["imd_tipo_deporte"]["ficha_alumnos_online.Codigo_deporte"] = array();
		}
		$lookupTableLinks["imd_tipo_deporte"]["ficha_alumnos_online.Codigo_deporte"]["search"] = array("table" => "Ficha Alumnos Online", "field" => "Codigo_deporte", "page" => "search");
		if( !isset( $lookupTableLinks["imd_categoria_deporte"] ) ) {
			$lookupTableLinks["imd_categoria_deporte"] = array();
		}
		if( !isset( $lookupTableLinks["imd_categoria_deporte"]["ficha_baseball.Codigo_CatDep"] )) {
			$lookupTableLinks["imd_categoria_deporte"]["ficha_baseball.Codigo_CatDep"] = array();
		}
		$lookupTableLinks["imd_categoria_deporte"]["ficha_baseball.Codigo_CatDep"]["search"] = array("table" => "Ficha Baseball", "field" => "Codigo_CatDep", "page" => "search");
		if( !isset( $lookupTableLinks["imd_tipo_deporte"] ) ) {
			$lookupTableLinks["imd_tipo_deporte"] = array();
		}
		if( !isset( $lookupTableLinks["imd_tipo_deporte"]["listado_de_allumnos_baseball.Codigo_Deporte"] )) {
			$lookupTableLinks["imd_tipo_deporte"]["listado_de_allumnos_baseball.Codigo_Deporte"] = array();
		}
		$lookupTableLinks["imd_tipo_deporte"]["listado_de_allumnos_baseball.Codigo_Deporte"]["search"] = array("table" => "Listado de Allumnos Baseball", "field" => "Codigo_Deporte", "page" => "search");
		if( !isset( $lookupTableLinks["imd_categoria_deporte"] ) ) {
			$lookupTableLinks["imd_categoria_deporte"] = array();
		}
		if( !isset( $lookupTableLinks["imd_categoria_deporte"]["listado_de_allumnos_baseball.Codigo_CatDep"] )) {
			$lookupTableLinks["imd_categoria_deporte"]["listado_de_allumnos_baseball.Codigo_CatDep"] = array();
		}
		$lookupTableLinks["imd_categoria_deporte"]["listado_de_allumnos_baseball.Codigo_CatDep"]["search"] = array("table" => "Listado de Allumnos Baseball", "field" => "Codigo_CatDep", "page" => "search");
		if( !isset( $lookupTableLinks["imd_categoria_deporte"] ) ) {
			$lookupTableLinks["imd_categoria_deporte"] = array();
		}
		if( !isset( $lookupTableLinks["imd_categoria_deporte"]["listado_alumnos_futbol.Codigo_CatDep"] )) {
			$lookupTableLinks["imd_categoria_deporte"]["listado_alumnos_futbol.Codigo_CatDep"] = array();
		}
		$lookupTableLinks["imd_categoria_deporte"]["listado_alumnos_futbol.Codigo_CatDep"]["edit"] = array("table" => "Listado Alumnos Futbol", "field" => "Codigo_CatDep", "page" => "edit");
		if( !isset( $lookupTableLinks["imd_tipo_deporte"] ) ) {
			$lookupTableLinks["imd_tipo_deporte"] = array();
		}
		if( !isset( $lookupTableLinks["imd_tipo_deporte"]["listado_alumnos_futbol.Codigo_Deporte"] )) {
			$lookupTableLinks["imd_tipo_deporte"]["listado_alumnos_futbol.Codigo_Deporte"] = array();
		}
		$lookupTableLinks["imd_tipo_deporte"]["listado_alumnos_futbol.Codigo_Deporte"]["edit"] = array("table" => "Listado Alumnos Futbol", "field" => "Codigo_Deporte", "page" => "edit");
		if( !isset( $lookupTableLinks["imd_categoria_deporte"] ) ) {
			$lookupTableLinks["imd_categoria_deporte"] = array();
		}
		if( !isset( $lookupTableLinks["imd_categoria_deporte"]["ficha_fubtol_femenino.Codigo_CatDep"] )) {
			$lookupTableLinks["imd_categoria_deporte"]["ficha_fubtol_femenino.Codigo_CatDep"] = array();
		}
		$lookupTableLinks["imd_categoria_deporte"]["ficha_fubtol_femenino.Codigo_CatDep"]["search"] = array("table" => "Ficha Fubtol Femenino", "field" => "Codigo_CatDep", "page" => "search");
		if( !isset( $lookupTableLinks["imd_categoria_deporte"] ) ) {
			$lookupTableLinks["imd_categoria_deporte"] = array();
		}
		if( !isset( $lookupTableLinks["imd_categoria_deporte"]["ficha_softbal_femenino.Codigo_CatDep"] )) {
			$lookupTableLinks["imd_categoria_deporte"]["ficha_softbal_femenino.Codigo_CatDep"] = array();
		}
		$lookupTableLinks["imd_categoria_deporte"]["ficha_softbal_femenino.Codigo_CatDep"]["search"] = array("table" => "Ficha softbal Femenino", "field" => "Codigo_CatDep", "page" => "search");
}

?>